Rebol[
	Title: "Documentation automatique fichiers .py"
	filename: %docPython2html.r
	author: "J. Colineau"
	date: "Sept, 28 , 2007" 
	comments: {le script lit tous les fichiers .py du rpertoire choisi,
	en extrait l'en-tte, et le sauvegarde dans un fichier au format html
	on utilise des fonctions tires de makespec.r}
]
	
get-creation-date: func [fichier][
	p: open  fichier
	str: copy to-string get-modes p 'creation-date
	parse str [copy date to "/" to end]
	close p
	date]
	
get-modif-date: func [fichier][
	p: open  fichier
	str: copy to-string get-modes p 'modification-date
	parse str [copy date to "/" to end]
	close p
	date]
	
get-file-header: func [{ fichiers Python ...} 
		fichier /local en-tete str][
	en-tete: copy ""
	str: copy ""
 	str:  read/lines to-file fichier
 	foreach ligne str[
 		if(found? find ligne "def ") [ append en-tete rejoin [" " ligne newline ]]]
 	commentaires: 0
 	foreach ligne str[
 	; 	if/else (ligne == "") [if (commentaires > 0) [ break]]
 	;	[if (found? find ligne "#") [ commentaires: 1 append en-tete rejoin [" " ligne newline ]]]
 		if (found? find ligne {^"^"^"})[if/else (commentaires == 0) [commentaires: 1 ][ commentaires: 0 break]]
 		if (commentaires == 1) [append en-tete rejoin [" " ligne newline ]]
 	]
 	return en-tete
	]
	
;----------------- extrait de makespec.r -------------
text-to-html: make object! [
    html: make string! 10000
    emit: func [data] [append html reduce data]
    code: text: none
    subnum: sectnum: toc-marker: 0
    sections: []
    space: charset " ^-"
    chars: complement charset " ^-^/"
    font: <font face="arial,helvetica">
    marg-in: <blockquote>
    marg-out: </blockquote>

    escape-html: func [
        "Format a code example" code
    ][
        replace/all code "&" "&amp;"
        replace/all code "<" "&lt;"
        replace/all code ">" "&gt;"
        insert code [<b><pre>]
        append code reduce [</pre></b> newline]
    ]

    ;--- Text Format Language:
    rules: [title some parts done]
    title: [text-line 
        (emit [<html><title>text</title><body>font<h2>text</h2></font><p>])]
    parts: [newline | "===" section | "---" subsect |
        "#indent" (emit marg-in) | "/indent" (emit marg-out) |
        "#side" side | "/side" (emit [</TD></TR></TABLE>]) |
         "###" to end (emit [marg-out "-End-"]) | example | paragraph]
    section: [
        text-line (
            if sectnum > 0 [emit marg-out]
            sectnum: sectnum + 1 subnum: 1
            if sectnum = 1 [toc-marker: length? html]
            emit [{<HR><P>} {<A NAME="section-} sectnum {"></A>}]
            emit [<p>font<h3>(head insert text reduce [sectnum ". "])</h3></font><p>]
            append sections rejoin [{<A HREF="#section-} sectnum {">} text </A>]
            emit marg-in
        ) newline
    ]
    subsect: [text-line
        (emit [<p>font<i><h4>head insert trim text reduce [sectnum "." subnum ". "]
            </h4></i></font><p>] subnum: subnum + 1) newline]
    example: [copy code some [indented | some newline indented]
        (emit escape-html code)]
    paragraph: [copy para some [chars thru newline] (emit [para<p>])]
    done: [(emit [</body></html>])]
    text-line: [copy text thru newline]
    indented: [some space thru newline]
    side: [text-line
        (emit [<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="80%">
            <TR><TD WIDTH="100%" BGCOLOR="black"><B>
            <FONT COLOR="white" FACE="Arial, Helvetica"> text
            </FONT></B></TD></TR> <TR><TD WIDTH="100%">
        ])
    ]

    make-contents: func [] [
        html: skip html toc-marker
        html: insert html reduce [<P><HR><P>font<h3>"Liste des fichiers: "</h3></font><p>marg-in<B>]
        foreach section sections [
            html: insert html reduce [section <BR>]
        ]
        insert html reduce [</B> marg-out <P>]
        html: head html
    ]
    convert: func [data] [
        clear html: head html
        subnum: sectnum: toc-marker: 0
        sections: clear []
        parse/all detab data rules
        make-contents
        html
    ]
]

;-------------------------------------------

log-file: ""
log-str: ""
log-rep: what-dir

a: request-file/path/filter "*.py"
rep: first a
change-dir to-file rep
files: read to-file rep
files-m: []
en-tete: ""

foreach file files[
	ext: to-string suffix? file 
	if (ext == ".py")
	[append files-m file]
	]
files-m: head files-m

log-str: rejoin ["Liste des fichiers Python du rpertoire         " rep newline " " newline]
append log-str rejoin ["Documentation cre automatiquement le " now/date " par MyDoc - J.Colineau " newline newline]
	
foreach file files-m[
	append log-str rejoin ["===" file newline newline] 
	append log-str rejoin ["     cr le " (get-creation-date file) "     modifi le " (get-modif-date file) newline " "  newline]	
	append log-str get-file-header file 
 	append log-str join " " newline
 	]
 	
change-dir to-file log-rep
b: request-file/filter "*.html"	
log-file: to-file b

if not find log-file ".html" [append log-file ".html"]
data: text-to-html/convert log-str 
write log-file data

browse log-file